diff --git a/src/Geom2dHatch/Geom2dHatch_FClass2dOfClassifier.hxx b/src/Geom2dHatch/Geom2dHatch_FClass2dOfClassifier.hxx
index f4e25ee..69e9315 100644
--- a/src/Geom2dHatch/Geom2dHatch_FClass2dOfClassifier.hxx
+++ b/src/Geom2dHatch/Geom2dHatch_FClass2dOfClassifier.hxx
@@ -17,24 +17,15 @@
 #ifndef _Geom2dHatch_FClass2dOfClassifier_HeaderFile
 #define _Geom2dHatch_FClass2dOfClassifier_HeaderFile
 
-#include <Standard.hxx>
 #include <Standard_DefineAlloc.hxx>
-#include <Standard_Handle.hxx>
 
-#include <Standard_Boolean.hxx>
-#include <gp_Lin2d.hxx>
-#include <Standard_Real.hxx>
-#include <TopTrans_CurveTransition.hxx>
 #include <Geom2dHatch_Intersector.hxx>
-#include <Standard_Integer.hxx>
-#include <TopAbs_State.hxx>
+#include <gp_Lin2d.hxx>
 #include <TopAbs_Orientation.hxx>
-class Standard_DomainError;
-class Geom2dAdaptor_Curve;
-class Geom2dHatch_Intersector;
-class gp_Lin2d;
-
+#include <TopAbs_State.hxx>
+#include <TopTrans_CurveTransition.hxx>
 
+class TopClass_GeomEdge;
 
 class Geom2dHatch_FClass2dOfClassifier 
 {
@@ -51,51 +42,44 @@ public:
   //! the original length of the segment on <L>  used to
   //! compute  intersections.   <Tol> is the   tolerance
   //! attached to the line segment in intersections.
-  Standard_EXPORT void Reset (const gp_Lin2d& L, const Standard_Real P, const Standard_Real Tol);
+  Standard_EXPORT void Reset (const gp_Lin2d& L, const Standard_Real P);
   
   //! Updates  the classification process with  the edge
   //! <E> from the boundary.
-  Standard_EXPORT void Compare (const Geom2dAdaptor_Curve& E, const TopAbs_Orientation Or);
+  //! theTol2D is 2D-tolerance using in intersector of theE with
+  //! the linear ray myLin
+  Standard_EXPORT void Compare(const TopClass_GeomEdge& theE,
+                               const Standard_Real theTol2D);
   
   //! Returns the current value of the parameter.
-    Standard_Real Parameter() const;
-  
+  Standard_Real Parameter() const;
+
   //! Returns the intersecting algorithm.
-    Geom2dHatch_Intersector& Intersector();
-  
+  Geom2dHatch_Intersector& Intersector();
+
   //! Returns  0  if  the   last  compared   edge had no
   //! relevant intersection.  Else returns  the index of
   //! this   intersection  in the    last   intersection
   //! algorithm.
-    Standard_Integer ClosestIntersection() const;
-  
+  Standard_Integer ClosestIntersection() const;
+
   //! Returns the current state of the point.
-    TopAbs_State State() const;
-  
+  TopAbs_State State() const;
+
   //! Returns the Standard_True if the closest intersection point
   //! represents head or end of the edge. Returns Standard_False
   //! otherwise.
-    Standard_Boolean IsHeadOrEnd() const;
-
-
-
+  Standard_Boolean IsHeadOrEnd() const;
 
 protected:
 
-
-
-
-
 private:
 
-
-
-  Standard_Boolean myIsSet;
   Standard_Boolean myFirstCompare;
   Standard_Boolean myFirstTrans;
   gp_Lin2d myLin;
   Standard_Real myParam;
-  Standard_Real myTolerance;
+
   TopTrans_CurveTransition myTrans;
   Geom2dHatch_Intersector myIntersector;
   Standard_Integer myClosest;
@@ -105,8 +89,6 @@ private:
 
 };
 
-#define TheEdge Geom2dAdaptor_Curve
-#define TheEdge_hxx <Geom2dAdaptor_Curve.hxx>
 #define TheIntersector Geom2dHatch_Intersector
 #define TheIntersector_hxx <Geom2dHatch_Intersector.hxx>
 #define TopClass_Classifier2d Geom2dHatch_FClass2dOfClassifier
@@ -114,8 +96,6 @@ private:
 
 #include <TopClass_Classifier2d.lxx>
 
-#undef TheEdge
-#undef TheEdge_hxx
 #undef TheIntersector
 #undef TheIntersector_hxx
 #undef TopClass_Classifier2d
diff --git a/src/Geom2dHatch/Geom2dHatch_FClass2dOfClassifier_0.cxx b/src/Geom2dHatch/Geom2dHatch_FClass2dOfClassifier_0.cxx
index ffb15c3..bcd71de 100644
--- a/src/Geom2dHatch/Geom2dHatch_FClass2dOfClassifier_0.cxx
+++ b/src/Geom2dHatch/Geom2dHatch_FClass2dOfClassifier_0.cxx
@@ -21,9 +21,6 @@
 #include <Geom2dHatch_Intersector.hxx>
 #include <gp_Lin2d.hxx>
  
-
-#define TheEdge Geom2dAdaptor_Curve
-#define TheEdge_hxx <Geom2dAdaptor_Curve.hxx>
 #define TheIntersector Geom2dHatch_Intersector
 #define TheIntersector_hxx <Geom2dHatch_Intersector.hxx>
 #define TopClass_Classifier2d Geom2dHatch_FClass2dOfClassifier
diff --git a/src/Geom2dHatch/Geom2dHatch_Hatcher.cxx b/src/Geom2dHatch/Geom2dHatch_Hatcher.cxx
index d27dc7e..959c6b2 100644
--- a/src/Geom2dHatch/Geom2dHatch_Hatcher.cxx
+++ b/src/Geom2dHatch/Geom2dHatch_Hatcher.cxx
@@ -21,6 +21,7 @@
 #include <Geom2dHatch_Hatcher.hxx>
 #include <Geom2dHatch_Hatching.hxx>
 #include <Geom2dHatch_Intersector.hxx>
+#include <GeomLib.hxx>
 #include <HatchGen_Domain.hxx>
 #include <HatchGen_Domains.hxx>
 #include <HatchGen_PointOnElement.hxx>
@@ -738,7 +739,8 @@ Standard_Boolean Geom2dHatch_Hatcher::Trim (const Standard_Integer IndH,
 //            IndH-th hatching.
 //=======================================================================
 
-Standard_Boolean Geom2dHatch_Hatcher::GlobalTransition (HatchGen_PointOnHatching& Point)
+Standard_Boolean 
+    Geom2dHatch_Hatcher::GlobalTransition (HatchGen_PointOnHatching& Point) const
 {
   TopAbs_State StateBefore = TopAbs_UNKNOWN ;
   TopAbs_State StateAfter  = TopAbs_UNKNOWN ;
@@ -751,7 +753,13 @@ Standard_Boolean Geom2dHatch_Hatcher::GlobalTransition (HatchGen_PointOnHatching
 
   const Geom2dAdaptor_Curve& CurveH = HatchingCurve (Point.Index()) ;
 
-  myIntersector.LocalGeometry(CurveH.Curve(), Point.Parameter(), Tangente2d, Normale2d, Courbure);
+  if(!GeomLib::LocalGeometry(CurveH.Curve(),
+                             Point.Parameter(),
+                             Tangente2d,
+                             Normale2d, Courbure))
+  {
+    return Standard_False;
+  }
 
   Tangente.SetCoord (Tangente2d.X(), Tangente2d.Y(), 0.0) ;
   if (Courbure < Precision::Confusion()) {
@@ -805,7 +813,14 @@ Standard_Boolean Geom2dHatch_Hatcher::GlobalTransition (HatchGen_PointOnHatching
 #endif
     Param = PntE.Parameter();
 
-    myIntersector.LocalGeometry(CurveE.Curve(), Param, Tangente2d, Normale2d, Courbure);
+    if(!GeomLib::LocalGeometry(CurveE.Curve(),
+                                  Param,
+                                  Tangente2d,
+                                  Normale2d,
+                                  Courbure))
+    {
+      return Standard_False;
+    }
 
 //-----------------------------------------------------------------------
 // Calcul de la transition locale. On suppose les relations suivantes :
@@ -972,7 +987,11 @@ void Geom2dHatch_Hatcher::ComputeDomains (const Standard_Integer IndH)
   if(NbPnt == 0)
   {
     //-- cout << "The hatching # " << setw(3) << IndH << " has to be classified" << endl ;
-    Geom2dHatch_Classifier Classifier(myElements,Hatching.ClassificationPoint(),0.0000001); 
+    Geom2dHatch_Classifier Classifier;
+    Classifier.Perform(myElements,
+                       Hatching.ClassificationPoint(),
+                       Precision::PConfusion());
+
     if(Classifier.State() == TopAbs_IN)
     { 
       HatchGen_Domain domain ;
diff --git a/src/Geom2dHatch/Geom2dHatch_Hatcher.hxx b/src/Geom2dHatch/Geom2dHatch_Hatcher.hxx
index cbef299..9ba30e7 100644
--- a/src/Geom2dHatch/Geom2dHatch_Hatcher.hxx
+++ b/src/Geom2dHatch/Geom2dHatch_Hatcher.hxx
@@ -195,7 +195,7 @@ private:
   
   //! Sets the global transition (the before and after
   //! states and segment extremities flags) of the point.
-  Standard_EXPORT Standard_Boolean GlobalTransition (HatchGen_PointOnHatching& Point);
+  Standard_EXPORT Standard_Boolean GlobalTransition (HatchGen_PointOnHatching& Point) const;
 
 
   Geom2dHatch_Intersector myIntersector;
diff --git a/src/Geom2dHatch/Geom2dHatch_Intersector.cxx b/src/Geom2dHatch/Geom2dHatch_Intersector.cxx
index 13622c0..e146a40 100644
--- a/src/Geom2dHatch/Geom2dHatch_Intersector.cxx
+++ b/src/Geom2dHatch/Geom2dHatch_Intersector.cxx
@@ -23,6 +23,7 @@
 #include <gp_Dir2d.hxx>
 #include <gp_Lin2d.hxx>
 #include <Precision.hxx>
+#include <TopClass_GeomEdge.hxx>
 
 //=======================================================================
 //function : Geom2dHatch_Intersector
@@ -39,63 +40,33 @@ myTangencyTolerance(0.0)
 //purpose  : 
 //=======================================================================
 
-void  Geom2dHatch_Intersector::Perform(const gp_Lin2d& L, 
-				       const Standard_Real P, 
-				       const Standard_Real Tol, 
-				       const Geom2dAdaptor_Curve& C)
+void  Geom2dHatch_Intersector::Perform(const gp_Lin2d& theLin, 
+                                       const Standard_Real thePar, 
+                                       const Standard_Real theTol2D,
+                                       const TopClass_GeomEdge& theGE)
 {
-  
-//Standard_Real pfbid,plbid;
+  const gp_Pnt2d &aPnt2D = theLin.Location();
   IntRes2d_Domain DL;
-  if(P!=RealLast()) 
-    DL.SetValues(L.Location(),0.,Tol,ElCLib::Value(P,L),P,Tol);
-  else 
-    DL.SetValues(L.Location(),0.,Tol,Standard_True);
-  
-  IntRes2d_Domain DE(C.Value(C.FirstParameter()),
-		     C.FirstParameter(),Precision::PIntersection(),
-		     C.Value(C.LastParameter()),
-		     C.LastParameter(),Precision::PIntersection());
-  
-  Handle(Geom2d_Line) GL= new Geom2d_Line(L);
-  Geom2dAdaptor_Curve CGA(GL);
-  void *ptrpoureviterlesproblemesdeconst = (void *)(&C);
-
-  Geom2dInt_GInter Inter(CGA,
-			 DL,
-			 *((Geom2dAdaptor_Curve *)ptrpoureviterlesproblemesdeconst),
-			 DE,
-			 Precision::PConfusion(),
-			 Precision::PIntersection());
-  this->SetValues(Inter);
-}
-
-//=======================================================================
-//function : LocalGeometry
-//purpose  : 
-//=======================================================================
-
-void  Geom2dHatch_Intersector::LocalGeometry(const Geom2dAdaptor_Curve& E, 
-					     const Standard_Real U, 
-					     gp_Dir2d& Tang, 
-					     gp_Dir2d& Norm, 
-					     Standard_Real& C) const 
-{
-  //Standard_Real f,l;
-  Geom2dLProp_CLProps2d Prop(E.Curve(),U,2,Precision::PConfusion());
-
-  if(!Prop.IsTangentDefined()) return;
-
-  Prop.Tangent(Tang);
-  C = Prop.Curvature();
-  if (C > Precision::PConfusion() && C<RealLast())
-    Prop.Normal(Norm);
+  if(thePar != RealLast())
+    DL.SetValues(aPnt2D, 0., theTol2D, ElCLib::Value(thePar, theLin), thePar, theTol2D);
   else
-    Norm.SetCoord(Tang.Y(),-Tang.X());
-}
-
-
+    DL.SetValues(aPnt2D, 0., theTol2D, Standard_True);
 
+  const Geom2dAdaptor_Curve &anAC = theGE.Get2DCurve();
 
+  IntRes2d_Domain DE(anAC.Value(anAC.FirstParameter()),
+                     anAC.FirstParameter(), Precision::PIntersection(),
+                     anAC.Value(anAC.LastParameter()),
+                     anAC.LastParameter(), Precision::PIntersection());
 
+  Handle(Geom2d_Line) GL = new Geom2d_Line(theLin);
+  Geom2dAdaptor_Curve CGA(GL);
 
+  Geom2dInt_GInter Inter(CGA,
+                         DL,
+                         anAC,
+                         DE,
+                         Precision::PConfusion(),
+                         Precision::PIntersection());
+  this->SetValues(Inter);
+}
diff --git a/src/Geom2dHatch/Geom2dHatch_Intersector.hxx b/src/Geom2dHatch/Geom2dHatch_Intersector.hxx
index c3968d0..69e963f 100644
--- a/src/Geom2dHatch/Geom2dHatch_Intersector.hxx
+++ b/src/Geom2dHatch/Geom2dHatch_Intersector.hxx
@@ -17,17 +17,11 @@
 #ifndef _Geom2dHatch_Intersector_HeaderFile
 #define _Geom2dHatch_Intersector_HeaderFile
 
-#include <Standard.hxx>
-#include <Standard_DefineAlloc.hxx>
-#include <Standard_Handle.hxx>
-
-#include <Standard_Real.hxx>
 #include <Geom2dInt_GInter.hxx>
+
 class Geom2dAdaptor_Curve;
 class gp_Lin2d;
-class gp_Dir2d;
-
-
+class TopClass_GeomEdge;
 
 class Geom2dHatch_Intersector  : public Geom2dInt_GInter
 {
@@ -61,33 +55,21 @@ public:
   
   Standard_EXPORT Geom2dHatch_Intersector();
   
-  //! Performs the intersection   between the  2d   line
-  //! segment (<L>, <P>) and  the  Curve <E>.  The  line
-  //! segment  is the  part  of  the  2d   line   <L> of
-  //! parameter range [0, <P>] (P is positive and can be
-  //! RealLast()). Tol is the  Tolerance on the segment.
-  //! The order  is relevant, the  first argument is the
-  //! segment, the second the Edge.
-  Standard_EXPORT void Perform (const gp_Lin2d& L, const Standard_Real P, const Standard_Real Tol, const Geom2dAdaptor_Curve& E);
+  //! Performs the intersection between the 2d line
+  //! segment (<theLin>, <thePar>) and the Curve <theGE>.
+  //! The line segment is the part of the 2d line <theLin> of
+  //! parameter range [0, <thePar>] (thePar is positive and can be
+  //! RealLast()). theTol2D is the Tolerance on the segment.
+  //! The order is relevant, the first argument is the
+  //! segment, the second one is the Edge.
+  Standard_EXPORT void Perform(const gp_Lin2d& theLin,
+                               const Standard_Real thePar,
+                               const Standard_Real theTol2D,
+                               const TopClass_GeomEdge& theGE);
   
-  //! Returns in <T>,  <N> and <C>  the tangent,  normal
-  //! and  curvature of the edge  <E> at parameter value
-  //! <U>.
-  Standard_EXPORT void LocalGeometry (const Geom2dAdaptor_Curve& E, const Standard_Real U, gp_Dir2d& T, gp_Dir2d& N, Standard_Real& C) const;
-
-
-
-
 protected:
-
-
-
-
-
+  
 private:
-
-
-
   Standard_Real myConfusionTolerance;
   Standard_Real myTangencyTolerance;
 
diff --git a/src/GeomInt/GeomInt_IntSS.cxx b/src/GeomInt/GeomInt_IntSS.cxx
index 0e2d7c9..ecea88b 100644
--- a/src/GeomInt/GeomInt_IntSS.cxx
+++ b/src/GeomInt/GeomInt_IntSS.cxx
@@ -76,9 +76,9 @@ void GeomInt_IntSS::Perform(const Handle(Geom_Surface)& S1,
   myTolReached2d = myTolReached3d = 0.0;
   myNbrestr = 0;
   sline.Clear();
-  Handle(Adaptor3d_TopolTool) dom1 = new Adaptor3d_TopolTool(myHS1);
-  Handle(Adaptor3d_TopolTool) dom2 = new Adaptor3d_TopolTool(myHS2);
-  myLConstruct.Load(dom1,dom2,myHS1,myHS2);
+  Handle(Adaptor3d_TopolTool) aDom1 = new Adaptor3d_TopolTool(myHS1);
+  Handle(Adaptor3d_TopolTool) aDom2 = new Adaptor3d_TopolTool(myHS2);
+  myLConstruct.Load(aDom1,aDom2,myHS1,myHS2);
 
   Standard_Real TolArc = Tol;
   Standard_Real TolTang = Tol;
@@ -88,13 +88,13 @@ void GeomInt_IntSS::Perform(const Handle(Geom_Surface)& S1,
   myIntersector.SetTolerances(TolArc,TolTang,UVMaxStep,Deflection);
 
   if(myHS1 == myHS2) {
-    myIntersector.Perform(myHS1,dom1,TolArc,TolTang);
+    myIntersector.Perform(myHS1,aDom1,TolArc,TolTang);
   }
   else if (!useStart) {
-    myIntersector.Perform(myHS1,dom1,myHS2,dom2,TolArc,TolTang);
+    myIntersector.Perform(myHS1,aDom1,myHS2,aDom2,TolArc,TolTang);
   }
   else {
-    myIntersector.Perform(myHS1,dom1,myHS2,dom2,U1,V1,U2,V2,TolArc,TolTang);
+    myIntersector.Perform(myHS1,aDom1,myHS2,aDom2,U1,V1,U2,V2,TolArc,TolTang);
   }
 
   // ============================================================
@@ -102,7 +102,7 @@ void GeomInt_IntSS::Perform(const Handle(Geom_Surface)& S1,
     const Standard_Integer nblin = myIntersector.NbLines();
     for (Standard_Integer i=1; i<= nblin; i++)
     {
-      MakeCurve(i,dom1,dom2,Tol,Approx,ApproxS1,ApproxS2);
+      MakeCurve(i,aDom1,aDom2,Tol,Approx,ApproxS1,ApproxS2);
     }
   }
 }
diff --git a/src/GeomInt/GeomInt_IntSS_1.cxx b/src/GeomInt/GeomInt_IntSS_1.cxx
index 5cac732..0e8c736 100644
--- a/src/GeomInt/GeomInt_IntSS_1.cxx
+++ b/src/GeomInt/GeomInt_IntSS_1.cxx
@@ -257,13 +257,12 @@ static Standard_Boolean isDegenerated(const Handle(GeomAdaptor_HSurface)& theGAH
 //purpose  : 
 //=======================================================================
 void GeomInt_IntSS::MakeCurve(const Standard_Integer Index,
-			                        const Handle(Adaptor3d_TopolTool) & dom1,
-			                        const Handle(Adaptor3d_TopolTool) & dom2,
-			                        const Standard_Real Tol,
-			                        const Standard_Boolean Approx,
-			                        const Standard_Boolean ApproxS1,
-			                        const Standard_Boolean ApproxS2)
-
+                              const Handle(Adaptor3d_TopolTool) & theDom1,
+                              const Handle(Adaptor3d_TopolTool) & theDom2,
+                              const Standard_Real Tol,
+                              const Standard_Boolean Approx,
+                              const Standard_Boolean ApproxS1,
+                              const Standard_Boolean ApproxS2)
 {
   Standard_Boolean myApprox1, myApprox2, myApprox;
   Standard_Real Tolpc, myTolApprox;
@@ -370,7 +369,7 @@ void GeomInt_IntSS::MakeCurve(const Standard_Integer Index,
         }
         Standard_Boolean bFNIt, bLPIt;
         Standard_Real aTestPrm, dT=100.;
-        Standard_Real u1, v1, u2, v2, TolX;
+        Standard_Real u1, v1, u2, v2;
         //
         bFNIt=Precision::IsNegativeInfinite(fprm);
         bLPIt=Precision::IsPositiveInfinite(lprm);
@@ -386,11 +385,10 @@ void GeomInt_IntSS::MakeCurve(const Standard_Integer Index,
         //
         gp_Pnt ptref(newc->Value(aTestPrm));
         //
-        TolX = Precision::Confusion();
         Parameters(myHS1, myHS2, ptref,  u1, v1, u2, v2);
-        ok = (dom1->Classify(gp_Pnt2d(u1, v1), TolX) != TopAbs_OUT);
+        ok = (theDom1->Classify(gp_Pnt2d(u1, v1), Precision::Confusion()) != TopAbs_OUT);
         if(ok) { 
-          ok = (dom2->Classify(gp_Pnt2d(u2,v2),TolX) != TopAbs_OUT); 
+          ok = (theDom2->Classify(gp_Pnt2d(u2, v2), Precision::Confusion()) != TopAbs_OUT);
         }
         if (ok) {
           sline.Append(newc);
@@ -499,18 +497,17 @@ void GeomInt_IntSS::MakeCurve(const Standard_Integer Index,
           }
         }
         //
-        Standard_Real aTwoPIdiv17, u1, v1, u2, v2, TolX;
+        Standard_Real aTwoPIdiv17, u1, v1, u2, v2;
         //
         aTwoPIdiv17=2.*M_PI/17.;
         //
         for (j=0; j<=17; j++) {
           gp_Pnt ptref (newc->Value (j*aTwoPIdiv17));
-          TolX = Precision::Confusion();
 
           Parameters(myHS1, myHS2, ptref, u1, v1, u2, v2);
-          ok = (dom1->Classify(gp_Pnt2d(u1,v1),TolX) != TopAbs_OUT);
+          ok = (theDom1->Classify(gp_Pnt2d(u1, v1), Precision::Confusion()) != TopAbs_OUT);
           if(ok) { 
-            ok = (dom2->Classify(gp_Pnt2d(u2,v2),TolX) != TopAbs_OUT);
+            ok = (theDom2->Classify(gp_Pnt2d(u2, v2), Precision::Confusion()) != TopAbs_OUT);
           }
           if (ok) {
             sline.Append(newc);
diff --git a/src/GeomInt/GeomInt_LineConstructor.cxx b/src/GeomInt/GeomInt_LineConstructor.cxx
index 60948f4..f8dfb76 100644
--- a/src/GeomInt/GeomInt_LineConstructor.cxx
+++ b/src/GeomInt/GeomInt_LineConstructor.cxx
@@ -139,7 +139,7 @@ void GeomInt_LineConstructor::Perform(const Handle(IntPatch_Line)& L)
 {
   Standard_Integer i,nbvtx;
   Standard_Real firstp,lastp;
-  const Standard_Real Tol = Precision::PConfusion() * 35.0;
+  const Standard_Real aTol = Precision::Confusion();
   
   const IntPatch_IType typl = L->ArcType();
   if(typl == IntPatch_Analytic)  {
@@ -155,9 +155,9 @@ void GeomInt_LineConstructor::Perform(const Handle(IntPatch_Line)& L)
         const gp_Pnt Pmid = ALine->Value(pmid);
         Parameters(myHS1,myHS2,Pmid,u1,v1,u2,v2);
         Recadre(myHS1,myHS2,u1,v1,u2,v2);
-        const TopAbs_State in1 = myDom1->Classify(gp_Pnt2d(u1,v1),Tol);
+        const TopAbs_State in1 = myDom1->Classify(gp_Pnt2d(u1,v1),aTol);
         if(in1 !=  TopAbs_OUT) {
-          const TopAbs_State in2 = myDom2->Classify(gp_Pnt2d(u2,v2),Tol);
+          const TopAbs_State in2 = myDom2->Classify(gp_Pnt2d(u2,v2),aTol);
           if(in2 != TopAbs_OUT) { 
             seqp.Append(firstp);
             seqp.Append(lastp);
@@ -182,9 +182,9 @@ void GeomInt_LineConstructor::Perform(const Handle(IntPatch_Line)& L)
           const IntSurf_PntOn2S& Pmid = WLine->Point(pmid);
           Pmid.Parameters(u1,v1,u2,v2);
           Recadre(myHS1,myHS2,u1,v1,u2,v2);
-          const TopAbs_State in1 = myDom1->Classify(gp_Pnt2d(u1,v1),Tol);
+          const TopAbs_State in1 = myDom1->Classify(gp_Pnt2d(u1, v1), aTol);
           if(in1 !=  TopAbs_OUT) {   
-            const TopAbs_State in2 = myDom2->Classify(gp_Pnt2d(u2,v2),Tol);
+            const TopAbs_State in2 = myDom2->Classify(gp_Pnt2d(u2, v2), aTol);
             if(in2 != TopAbs_OUT) {   
               seqp.Append(firstp);
               seqp.Append(lastp);
@@ -195,16 +195,16 @@ void GeomInt_LineConstructor::Perform(const Handle(IntPatch_Line)& L)
           const IntSurf_PntOn2S& Pfirst = WLine->Point((Standard_Integer)(firstp));
           Pfirst.Parameters(u1,v1,u2,v2);
           Recadre(myHS1,myHS2,u1,v1,u2,v2);
-          TopAbs_State in1 = myDom1->Classify(gp_Pnt2d(u1,v1),Tol);
+          TopAbs_State in1 = myDom1->Classify(gp_Pnt2d(u1, v1), aTol);
           if(in1 !=  TopAbs_OUT) {  //-- !=ON donne Pb 
-            TopAbs_State in2 = myDom2->Classify(gp_Pnt2d(u2,v2),Tol);
+            TopAbs_State in2 = myDom2->Classify(gp_Pnt2d(u2, v2), aTol);
             if(in2 != TopAbs_OUT) { //-- !=ON  
               const IntSurf_PntOn2S& Plast = WLine->Point((Standard_Integer)(lastp));
               Plast.Parameters(u1,v1,u2,v2);
               Recadre(myHS1,myHS2,u1,v1,u2,v2);
-              in1 = myDom1->Classify(gp_Pnt2d(u1,v1),Tol);
+              in1 = myDom1->Classify(gp_Pnt2d(u1, v1), aTol);
               if(in1 !=  TopAbs_OUT) {  //-- !=ON donne Pb 
-                in2 = myDom2->Classify(gp_Pnt2d(u2,v2),Tol);
+                in2 = myDom2->Classify(gp_Pnt2d(u2, v2), aTol);
                 if(in2 != TopAbs_OUT) {
                   seqp.Append(firstp);
                   seqp.Append(lastp);
@@ -289,7 +289,7 @@ void GeomInt_LineConstructor::Perform(const Handle(IntPatch_Line)& L)
     Handle(IntPatch_GLine) GLine (Handle(IntPatch_GLine)::DownCast (L));
     //
     if(typl == IntPatch_Circle || typl == IntPatch_Ellipse) { 
-      TreatCircle(L, Tol);
+      TreatCircle(L, aTol);
       done=Standard_True;
       return;
     }
@@ -310,9 +310,9 @@ void GeomInt_LineConstructor::Perform(const Handle(IntPatch_Line)& L)
         //
         Parameters(myHS1,myHS2,Pmid,u1,v1,u2,v2);
         Recadre(myHS1,myHS2,u1,v1,u2,v2);
-        const TopAbs_State in1 = myDom1->Classify(gp_Pnt2d(u1,v1),Tol);
+        const TopAbs_State in1 = myDom1->Classify(gp_Pnt2d(u1, v1), aTol);
         if(in1 !=  TopAbs_OUT) { 
-          const TopAbs_State in2 = myDom2->Classify(gp_Pnt2d(u2,v2),Tol);
+          const TopAbs_State in2 = myDom2->Classify(gp_Pnt2d(u2, v2), aTol);
           if(in2 != TopAbs_OUT) { 
             seqp.Append(firstp);
             seqp.Append(lastp);
@@ -376,7 +376,7 @@ void GeomInt_LineConstructor::Perform(const Handle(IntPatch_Line)& L)
     const Standard_Integer nbinserted = seqpss.Length();
     Standard_Boolean inserted = Standard_False;
     for (Standard_Integer j=1; j<=nbinserted;j++)    {
-      if (Abs(prm-seqpss(j).Parameter()) <= Tol)      {
+      if (Abs(prm-seqpss(j).Parameter()) <= aTol)      {
         // accumulate
         GeomInt_ParameterAndOrientation& valj = seqpss.ChangeValue(j);
         if (or1 != TopAbs_INTERNAL) {
@@ -404,7 +404,7 @@ void GeomInt_LineConstructor::Perform(const Handle(IntPatch_Line)& L)
         break;
       }
       
-      if (prm < seqpss(j).Parameter()-Tol ) {
+      if (prm < seqpss(j).Parameter()-aTol ) {
         // insert before position j
         seqpss.InsertBefore(j,GeomInt_ParameterAndOrientation(prm,or1,or2));
         inserted = Standard_True;
@@ -438,7 +438,7 @@ void GeomInt_LineConstructor::Perform(const Handle(IntPatch_Line)& L)
       if (!GeomInt_LineTool::Vertex(L,i).IsOnDomS1() )      {
         GeomInt_LineTool::Vertex(L,i).ParametersOnS1(U,V);
         gp_Pnt2d PPCC(U,V);
-        if (myDom1->Classify(PPCC,Tol) == TopAbs_OUT) {
+        if (myDom1->Classify(PPCC,aTol) == TopAbs_OUT) {
           done = Standard_True;
           return;
         }
@@ -462,7 +462,7 @@ void GeomInt_LineConstructor::Perform(const Handle(IntPatch_Line)& L)
     for (i=1; i<=GeomInt_LineTool::NbVertex(L); i++ )    {
       if (!GeomInt_LineTool::Vertex(L,i).IsOnDomS2() )      {
         GeomInt_LineTool::Vertex(L,i).ParametersOnS2(U,V);
-        if (myDom2->Classify(gp_Pnt2d(U,V),Tol) == TopAbs_OUT) {
+        if (myDom2->Classify(gp_Pnt2d(U,V),aTol) == TopAbs_OUT) {
           done = Standard_True;
           return;
         }
diff --git a/src/GeomLib/GeomLib.cxx b/src/GeomLib/GeomLib.cxx
index 4d004fa..cb4ca78 100644
--- a/src/GeomLib/GeomLib.cxx
+++ b/src/GeomLib/GeomLib.cxx
@@ -53,20 +53,6 @@
 #include <CSLib.hxx>
 #include <CSLib_NormalStatus.hxx>
 #include <ElCLib.hxx>
-#include <Geom2d_BezierCurve.hxx>
-#include <Geom2d_BSplineCurve.hxx>
-#include <Geom2d_Circle.hxx>
-#include <Geom2d_Curve.hxx>
-#include <Geom2d_Ellipse.hxx>
-#include <Geom2d_Hyperbola.hxx>
-#include <Geom2d_Line.hxx>
-#include <Geom2d_OffsetCurve.hxx>
-#include <Geom2d_Parabola.hxx>
-#include <Geom2d_TrimmedCurve.hxx>
-#include <Geom2dAdaptor_Curve.hxx>
-#include <Geom2dAdaptor_GHCurve.hxx>
-#include <Geom2dAdaptor_HCurve.hxx>
-#include <Geom2dConvert.hxx>
 #include <Geom_BezierCurve.hxx>
 #include <Geom_BezierSurface.hxx>
 #include <Geom_BoundedCurve.hxx>
@@ -84,6 +70,22 @@
 #include <Geom_RectangularTrimmedSurface.hxx>
 #include <Geom_Surface.hxx>
 #include <Geom_TrimmedCurve.hxx>
+#include <Geom2dAdaptor_Curve.hxx>
+#include <Geom2d_BezierCurve.hxx>
+#include <Geom2d_BSplineCurve.hxx>
+#include <Geom2d_Circle.hxx>
+#include <Geom2d_Curve.hxx>
+#include <Geom2d_Ellipse.hxx>
+#include <Geom2d_Hyperbola.hxx>
+#include <Geom2d_Line.hxx>
+#include <Geom2d_OffsetCurve.hxx>
+#include <Geom2d_Parabola.hxx>
+#include <Geom2d_TrimmedCurve.hxx>
+#include <Geom2dAdaptor_Curve.hxx>
+#include <Geom2dAdaptor_GHCurve.hxx>
+#include <Geom2dAdaptor_HCurve.hxx>
+#include <Geom2dConvert.hxx>
+#include <Geom2dLProp_CLProps2d.hxx>
 #include <GeomAdaptor_HSurface.hxx>
 #include <GeomAdaptor_Surface.hxx>
 #include <GeomConvert.hxx>
@@ -135,6 +137,7 @@
 #include <TColStd_Array2OfReal.hxx>
 #include <TColStd_HArray1OfReal.hxx>
 #include <TColStd_HArray2OfReal.hxx>
+
 //
 static Standard_Boolean CompareWeightPoles(const TColgp_Array1OfPnt& thePoles1, 
                                            const TColStd_Array1OfReal* const theW1,
@@ -2752,6 +2755,31 @@ Standard_Boolean GeomLib::IsBzVClosed (const Handle(Geom_BezierSurface)& S,
 }
 
 //=======================================================================
+//function : LocalGeometry
+//purpose  : 
+//=======================================================================
+Standard_Boolean GeomLib::LocalGeometry(const Handle(Geom2d_Curve)& theC,
+                                        const Standard_Real theParam,
+                                        gp_Dir2d& theTan,
+                                        gp_Dir2d& theNormal,
+                                        Standard_Real& theCurvature)
+{
+  Geom2dLProp_CLProps2d aProp(theC, theParam, 2, Precision::PConfusion());
+
+  if(!aProp.IsTangentDefined())
+    return Standard_False;
+
+  aProp.Tangent(theTan);
+  theCurvature = aProp.Curvature();
+  if((theCurvature > Precision::PConfusion()) && (theCurvature < RealLast()))
+    aProp.Normal(theNormal);
+  else
+    theNormal.SetCoord(theTan.Y(), -theTan.X());
+
+  return Standard_True;
+}
+
+//=======================================================================
 //function : CompareWeightPoles
 //purpose  : Checks if thePoles1(i)*theW1(i) is equal to thePoles2(i)*theW2(i)
 //            with tolerance theTol.
diff --git a/src/GeomLib/GeomLib.hxx b/src/GeomLib/GeomLib.hxx
index b51028d..cfaa956 100644
--- a/src/GeomLib/GeomLib.hxx
+++ b/src/GeomLib/GeomLib.hxx
@@ -223,6 +223,16 @@ public:
                                                         const Standard_Real V2,
                                                         const Standard_Real Tol);
 
+  //! Writes in <theTan>,  <theNormal> and <theCurvature>  the tangent,  normal
+  //! and  curvature of the curve <theC> at parameter value <theParam>.
+  //! Returns FALSE if properties cannot be computed.
+  Standard_EXPORT static
+    Standard_Boolean LocalGeometry(const Handle(Geom2d_Curve)& theC,
+                                      const Standard_Real theParam,
+                                      gp_Dir2d& theTan,
+                                      gp_Dir2d& theNormal,
+                                      Standard_Real& theCurvature);
+  
 protected:
 
 
diff --git a/src/GeometryTest/GeometryTest_CurveCommands.cxx b/src/GeometryTest/GeometryTest_CurveCommands.cxx
index 5e6ad44..2be5ad7 100644
--- a/src/GeometryTest/GeometryTest_CurveCommands.cxx
+++ b/src/GeometryTest/GeometryTest_CurveCommands.cxx
@@ -1772,6 +1772,44 @@ static Standard_Integer GetCurveContinuity( Draw_Interpretor& theDI,
 }
 
 //=======================================================================
+//function : GetResolution
+//purpose  : Returns the resolution of the given curve
+//=======================================================================
+static Standard_Integer GetResolution(Draw_Interpretor& theDI,
+                                      Standard_Integer theNArg,
+                                      const char** theArgv)
+{
+  if (theNArg != 3)
+  {
+    theDI << "Use: curvresolution <3d/2d-curve> toler \n";
+    return 1;
+  }
+
+  const Standard_Real aTol = Draw::Atof(theArgv[2]);  
+
+  Handle(Geom2d_Curve) aGC2d = DrawTrSurf::GetCurve2d(theArgv[1]);
+  Handle(Geom_Curve) aGC3d = DrawTrSurf::GetCurve(theArgv[1]);
+  if (aGC3d.IsNull() && aGC2d.IsNull())
+  {
+    theDI << theArgv[1] << " is not a 2D/3D-curve!\n";
+    return 1;
+  }
+
+  if (!aGC3d.IsNull())
+  {
+    Handle(Adaptor3d_HCurve) anAd = new GeomAdaptor_HCurve(aGC3d);
+    theDI << "Res3dCurve = " << anAd->Resolution(aTol) << "\n";
+  }
+  else //if (!aGC2d.IsNull())
+  {
+    Handle(Adaptor2d_HCurve2d) anAd = new Geom2dAdaptor_HCurve(aGC2d);
+    theDI << "Res2dCurve = " << anAd->Resolution(aTol) << "\n";
+  }
+
+  return 0;
+}
+
+//=======================================================================
 //function : CurveCommands
 //purpose  : 
 //=======================================================================
@@ -1878,6 +1916,10 @@ void  GeometryTest::CurveCommands(Draw_Interpretor& theCommands)
 		  __FILE__,
 		  GetCurveContinuity,g);
 
+  theCommands.Add("curvresolution",
+                  "curvresolution <3d/2d-curve> toler: \n\tReturns the resolution of the given curve",
+                  __FILE__,
+                  GetResolution, g);
 
 }
 
